// 216_1.cpp:   .

#include "stdafx.h"

#include <stdio.h> 
#include <math.h>

using namespace System;
using namespace System::Runtime::InteropServices;

#pragma unmanaged
//native-: 
struct Location {
	int x;
	int y;
};
//  -   :  
double GetDistance(Location loc1, Location loc2)
{
	printf("[unmanaged] loc1(%d, %d)", loc1.x, loc1.y); 
	printf(" loc2(%d, %d)\n", loc2.x, loc2.y);

	double h = loc1.x - loc2.x; 
	double v = loc1.y = loc2.y; 
	//   h2 + v2:
	double dist = sqrt( pow(h, 2) + pow(v, 2) );
	return dist;
}

//  -    
void InitLocation(Location* lp)
{
	printf("[unmanaged] Initializing location...\n"); 
	lp->x = 50; 
	lp->y = 50;
}
#pragma managed

//    managed-: 
void main()
{
	Location loc1;
	loc1.x = 0;
	loc1.y = 0;
	Location loc2; 
	loc2.x = 100; 
	loc2.y = 100;
	// native-  managed-: 
	double dist = GetDistance(loc1, loc2); 
	Console::WriteLine("[managed] distance = {0}", dist);
	
	Location loc3;
	// native-  managed- 
	//   ,   
	//   !
	InitLocation(&loc3);
	Console::WriteLine("[managed] x={0} ={1}", loc3.x, loc3.y);
	Console::ReadLine();
}
